From 784c97837355bedcf84f2aed9d2c608773a81d3a Mon Sep 17 00:00:00 2001
From: Dean Rasheed <dean.a.rasheed@gmail.com>
Date: Thu, 28 Sep 2023 14:54:02 +0100
Subject: [PATCH v27 7/8] Code review of infinite interval support.

---
 doc/src/sgml/func.sgml                    |   5 +-
 src/backend/utils/adt/date.c              |  27 +-
 src/backend/utils/adt/datetime.c          |   4 +-
 src/backend/utils/adt/selfuncs.c          |  16 +-
 src/backend/utils/adt/timestamp.c         | 366 +++++++++----------
 src/include/catalog/pg_aggregate.dat      |  11 +-
 src/include/catalog/pg_proc.dat           |   6 +-
 src/include/datatype/timestamp.h          |  24 +-
 src/include/utils/timestamp.h             |   3 -
 src/test/regress/expected/interval.out    | 375 ++++++++------------
 src/test/regress/expected/timestamp.out   |   8 +-
 src/test/regress/expected/timestamptz.out |   8 +-
 src/test/regress/expected/window.out      | 406 +++++++++++++++++++---
 src/test/regress/sql/interval.sql         | 131 +++----
 src/test/regress/sql/window.sql           |  93 ++++-
 15 files changed, 912 insertions(+), 571 deletions(-)

diff --git a/doc/src/sgml/func.sgml b/doc/src/sgml/func.sgml
index c4f09df544..682e3713c6 100644
--- a/doc/src/sgml/func.sgml
+++ b/doc/src/sgml/func.sgml
@@ -10435,7 +10435,10 @@ SELECT EXTRACT(YEAR FROM TIMESTAMP '2001-02-16 20:38:40');
      +/-Infinity for monotonically-increasing fields (<literal>epoch</literal>,
      <literal>julian</literal>, <literal>year</literal>, <literal>isoyear</literal>,
      <literal>decade</literal>, <literal>century</literal>, and <literal>millennium</literal>
-     for all types and <literal>hour</literal> and <literal>day</literal> just for <type>interval</type>).
+     for <type>timestamp</type> inputs; <literal>epoch</literal>, <literal>hour</literal>,
+     <literal>day</literal>, <literal>year</literal>, <literal>decade</literal>,
+     <literal>century</literal>, and <literal>millennium</literal> for
+     <type>interval</type> inputs).
      For other fields, NULL is returned.  <productname>PostgreSQL</productname>
      versions before 9.6 returned zero for all cases of infinite input.
     </para>
diff --git a/src/backend/utils/adt/date.c b/src/backend/utils/adt/date.c
index ad97f07601..cafe3abe21 100644
--- a/src/backend/utils/adt/date.c
+++ b/src/backend/utils/adt/date.c
@@ -24,6 +24,7 @@
 #include "access/xact.h"
 #include "catalog/pg_type.h"
 #include "common/hashfn.h"
+#include "common/int.h"
 #include "libpq/pqformat.h"
 #include "miscadmin.h"
 #include "nodes/supportnodes.h"
@@ -2050,8 +2051,6 @@ time_mi_time(PG_FUNCTION_ARGS)
 	result->day = 0;
 	result->time = time1 - time2;
 
-	Assert(!INTERVAL_NOT_FINITE(result));
-
 	PG_RETURN_INTERVAL_P(result);
 }
 
@@ -2116,7 +2115,8 @@ in_range_time_interval(PG_FUNCTION_ARGS)
 
 	/*
 	 * Like time_pl_interval/time_mi_interval, we disregard the month and day
-	 * fields of the offset.  So our test for negative should too.
+	 * fields of the offset.  So our test for negative should too.  This also
+	 * catches -infinity, so we only need worry about +infinity below.
 	 */
 	if (offset->time < 0)
 		ereport(ERROR,
@@ -2126,13 +2126,14 @@ in_range_time_interval(PG_FUNCTION_ARGS)
 	/*
 	 * We can't use time_pl_interval/time_mi_interval here, because their
 	 * wraparound behavior would give wrong (or at least undesirable) answers.
-	 * Fortunately the equivalent non-wrapping behavior is trivial, especially
-	 * since we don't worry about integer overflow.
+	 * Fortunately the equivalent non-wrapping behavior is trivial, except
+	 * that adding an infinite (or very large) interval might cause integer
+	 * overflow.  Subtraction cannot overflow here.
 	 */
 	if (sub)
 		sum = base - offset->time;
-	else
-		sum = base + offset->time;
+	else if (pg_add_s64_overflow(base, offset->time, &sum))
+		PG_RETURN_BOOL(less);
 
 	if (less)
 		PG_RETURN_BOOL(val <= sum);
@@ -2666,7 +2667,8 @@ in_range_timetz_interval(PG_FUNCTION_ARGS)
 
 	/*
 	 * Like timetz_pl_interval/timetz_mi_interval, we disregard the month and
-	 * day fields of the offset.  So our test for negative should too.
+	 * day fields of the offset.  So our test for negative should too. This
+	 * also catches -infinity, so we only need worry about +infinity below.
 	 */
 	if (offset->time < 0)
 		ereport(ERROR,
@@ -2676,13 +2678,14 @@ in_range_timetz_interval(PG_FUNCTION_ARGS)
 	/*
 	 * We can't use timetz_pl_interval/timetz_mi_interval here, because their
 	 * wraparound behavior would give wrong (or at least undesirable) answers.
-	 * Fortunately the equivalent non-wrapping behavior is trivial, especially
-	 * since we don't worry about integer overflow.
+	 * Fortunately the equivalent non-wrapping behavior is trivial, except
+	 * that adding an infinite (or very large) interval might cause integer
+	 * overflow.  Subtraction cannot overflow here.
 	 */
 	if (sub)
 		sum.time = base->time - offset->time;
-	else
-		sum.time = base->time + offset->time;
+	else if (pg_add_s64_overflow(base->time, offset->time, &sum.time))
+		PG_RETURN_BOOL(less);
 	sum.zone = base->zone;
 
 	if (less)
diff --git a/src/backend/utils/adt/datetime.c b/src/backend/utils/adt/datetime.c
index 73dadb747c..fca9a2a6e9 100644
--- a/src/backend/utils/adt/datetime.c
+++ b/src/backend/utils/adt/datetime.c
@@ -3613,9 +3613,9 @@ DecodeInterval(char **field, int *ftype, int nf, int range,
 							return DTERR_BAD_FORMAT;
 
 						/*
-						 * infinity can not be followed by anything else. We
+						 * Infinity cannot be followed by anything else. We
 						 * could allow "ago" to reverse the sign of infinity
-						 * but that signed infinity is more intuitive.
+						 * but using signed infinity is more intuitive.
 						 */
 						if (i != nf - 1)
 							return DTERR_BAD_FORMAT;
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index 6e87173846..4ea5415f20 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -4795,7 +4795,21 @@ convert_timevalue_to_scalar(Datum value, Oid typid, bool *failure)
 		case DATEOID:
 			return date2timestamp_no_overflow(DatumGetDateADT(value));
 		case INTERVALOID:
-			return interval2timestamp_no_overflow(DatumGetIntervalP(value));
+			{
+				Interval   *interval = DatumGetIntervalP(value);
+
+				/*
+				 * Convert the month part of Interval to days using assumed
+				 * average month length of 365.25/12.0 days.  Not too
+				 * accurate, but plenty good enough for our purposes.
+				 *
+				 * This also works for infinite intervals, which just have all
+				 * fields set to INT_MIN/INT_MAX, and so will produce a result
+				 * smaller/larger than any finite interval.
+				 */
+				return interval->time + interval->day * (double) USECS_PER_DAY +
+					interval->month * ((DAYS_PER_YEAR / (double) MONTHS_PER_YEAR) * USECS_PER_DAY);
+			}
 		case TIMEOID:
 			return DatumGetTimeADT(value);
 		case TIMETZOID:
